package;

import phoenix.Vector;

import Clock;
import luxe.Color;
import phoenix.Vector;
import luxe.Text;
import luxe.utils.Maths;
import luxe.tween.Actuate;


class Citizen extends luxe.Entity {
    static public var citizens = new Array<Citizen>();

    public var sprite:luxe.Sprite;
    public var last_pos:Vector;
    public var lastCopy:Float;
    public var is_badass:Bool;

    public function new(name:String) {
        super();
        this.name = name;
        var bobTex = Luxe.resources.texture("assets/maps/sprites/bob_"+Reg.rand.int(8)+".png");
        this.sprite = new luxe.Sprite({
            pos: new phoenix.Vector(0, 0),
            texture: bobTex,
        });
        last_pos = new phoenix.Vector(0, 0);
        lastCopy = 0;

        this.add(new LifeComponent());
        this.add(new CitizenFeature());

        Citizen.citizens.push(this);
    }

    static public function clock(hour:ClockTime) {
        for (citizen in Citizen.citizens) {
            citizen.get("life").clock(hour);
        }
    }

    override public function update(dt:Float) {
        lastCopy += dt;
        if (lastCopy > 0.1) {
            set_direction();
            last_pos.copy_from(sprite.pos);
            lastCopy = 0;
        }
        sprite.pos.copy_from(pos);
        check_badass();
        draw_name();
    }

    public function check_badass() {
        if(is_badass) {
            sprite.color = new Color(1,0,0,1);
        } else {
            sprite.color = new Color(1,1,1,1);
        }
    }

    public function set_direction() {

        var angle:Float = 270 + Maths.degrees(Vector.Subtract(last_pos, pos).angle2D);

        Actuate.tween (sprite,0.2, { rotation_z: angle });
    }

    public function draw_name() {
        var pos:Vector = new Vector(sprite.pos.x, sprite.pos.y - this.sprite.size.y - 18);
        Luxe.draw.text({
            immediate: true,
            align : TextAlign.center,
            color : new Color(0, 0, 0, 0.5),
            pos : pos,
            point_size : 18,
            text : name,
        });
    }
}
