package;

import luxe.tween.actuators.MotionPathActuator;
import luxe.tween.MotionPath;
import luxe.tween.actuators.GenericActuator;
import Clock;
import phoenix.Vector;
import luxe.Text;
import luxe.Color;
import luxe.Sprite;
import luxe.Entity;
import luxe.tween.Actuate;


class CitizenFeature extends luxe.Component {
    public var strength: Float = 1;
    public var conversion_rate: Float = 0;
    public var is_converted: Bool = false;
    public var is_weak: Bool = false;
    public var sprite: Sprite;
    var citizen:Citizen;

    public function new() {
        super({name: "citizen_feature"});
    }

    override public function init() {
        citizen = cast entity;
        sprite = citizen.sprite;
        strength = 1;
    }

    public function decrease_strength(power: Float) {
        Actuate.tween(this, 2, {strength: strength-power});
    }

    public function increase_strength(power: Float) {
        Actuate.tween(this, 2, {strength: strength+power});
    }

    public function check_strength() {
        if (strength > 1) {
            strength = 1;
        }

        if (strength < 0) {
            strength = 0;
        }

        if (strength < 0.2) {
            is_weak = true;
        } else {
            is_weak = false;
        }
    }

    public function increase_conversion(power: Float) {
        var new_conversion_rate = conversion_rate + power * (1 - strength);
        Actuate.tween(this, 2.5, {conversion_rate: new_conversion_rate});
    }

    public function change_strength() {
        var change_bad:Bool = Reg.rand.bool(0.2);
        if (change_bad) {
            var rate = Reg.rand.float(0.3, 0.5);
            decrease_strength(rate);
        } else {
            var rate = Reg.rand.int(0.3, 0.5);
            increase_strength(rate);
        }
    }

    override public function update(dt:Float) {
        if (conversion_rate > 1) {
            is_converted = true;
        }
        citizen.is_badass = is_converted;
        check_strength();
        if(!citizen.is_badass) {
            draw_feature();
        }
    }

    public function draw_feature() {
        var pos:Vector = new Vector();
        var pos2:Vector = new Vector();
        var stghtText:String = ""+Std.int(strength*100);
        var rateText:String = ""+Std.int(conversion_rate*100);
        pos.copy_from(sprite.pos);
        pos2.copy_from(sprite.pos);
        pos.y -= 10;
        pos2.y -= 10;

        pos.x += 30;
        //Draw rate
        Luxe.draw.text({
            immediate: true,
            align : TextAlign.center,
            color : new Color(0.5, 0, 0, 0.5),
            pos : pos,
            point_size : 18,
            text : rateText
        });
        //Draw strength
        pos2.x -= 30;
        Luxe.draw.text({
            immediate: true,
            align : TextAlign.center,
            color : new Color(0, 0, 0.5, 0.5),
            pos : pos2,
            point_size : 18,
            text : stghtText,
        });
    }
}

