package;
import luxe.Entity;
import luxe.Color;
import luxe.Vector;

import states.Play;


enum ClockTime {
    BEFORE;
    MORNING;
    NOON;
    EVENING;
    AFTER;
}

class Clock extends Entity {
    public static var important_moments_time = [8, 13, 18];
    static var important_moments_clocktime = [MORNING, NOON, EVENING];

    var normal_speedtime: Float;
    public var startTime: Float;
    var speedTime: Float;
    public var endTime: Float;
    public var actualTime: Float;
    var day: Int;

    var hour(get, null):Int;
    var minute(get, null):Int;

    var clocktime:ClockTime = AFTER;

    public var time_to_action = false;

    public function new(start:Float=7.75, end:Float=22.5, speed:Float=100) {
        super();
        startTime = start;
        endTime = end;
        normal_speedtime = speed;
        speedTime = speed;
        day = 0;
        start_new_day();
        this.add(new ClockUI());
    }

    public function start_new_day() {
        actualTime = startTime * 3600;
        for(citizen in Citizen.citizens) {
            var cf:CitizenFeature = cast citizen.get("citizen_feature");
            cf.change_strength();
        }
    }

    public function check_next_day() {
        if (actualTime > (endTime + 0.5) * 3600) {
            next_day();
        }
    }

    public function slowdown() {
        speedTime /= 10;
    }

    public function normal_speed() {
        speedTime = normal_speedtime;
    }

    public function check_clocktime() {
        var supposed_time = BEFORE;
        var action_time = false;

        for (i in 0...important_moments_time.length) {
            if (hour >= important_moments_time[i]) {
                supposed_time = important_moments_clocktime[i];
            }
            if (hour == important_moments_time[i] -1 && minute > 30) {
                action_time = true;
            }
        }
        if (hour >= Std.int(endTime)) {
            supposed_time = AFTER;
        }
        if (supposed_time != clocktime) {
            clocktime = supposed_time;
            Citizen.clock(clocktime);
        }

        if (action_time && ! time_to_action) {
            Reg.precheur.action_time(clocktime);
            time_to_action = action_time;
            this.slowdown();
        } else if (! action_time && time_to_action) {
            time_to_action = false;
            this.normal_speed();
            Reg.precheur.end_of_actiontime();
        }
    }

    public function next_day() {
        //TODO
        day += 1;
        check_if_victory();
        start_new_day();
    }

    public function check_if_victory() {
        var score = 0;
        for (citizen in Citizen.citizens) {
            var feature = citizen.get("citizen_feature");
            if (feature.is_converted == true) {
                score += 1;
            }
        }

        if (score >= 5) {
            var play:Play = cast Main.fsm.current_state;
            play.show_win(day);
            // TODO: victory in day.
        }
    }

    override public function update(dt:Float) {
        actualTime += dt * speedTime;
        check_clocktime();
        check_next_day();
        print_time();
    }

    public function get_hour() {
        return Math.floor(actualTime/3600);
    }

    public function get_minute() {
        return Std.int((actualTime%3600)/60);
    }

    public function get_hour_float() {
        return actualTime/3600;
    }

    public function get_minute_float() {
        return (actualTime%3600)/60;
    }

    public function print_time() {
        var minute_display;
        if (minute < 10) {
            minute_display = "0" + minute;
        } else {
            minute_display = "" + minute;
        }
        // Luxe.draw.text({
        //     immediate: true,
        //     color : new Color(0, 0, 0,0.5),
        //     pos : new Vector( 0, Luxe.screen.h - 40 ),
        //     text : "jour : " + day + " ->  " + hour + "H" + minute_display
        // });
    }
}
