package;

import luxe.tween.actuators.MotionPathActuator;
import luxe.tween.MotionPath;
import luxe.tween.actuators.GenericActuator;
import Clock;
import phoenix.Vector;
import luxe.Text;
import luxe.Color;
import luxe.Sprite;
import luxe.Entity;
import luxe.tween.Actuate;


class ClockUI extends luxe.Component {
    public var clockSprite: Sprite;
    public var hourSprite: Sprite;
    public var minSprite: Sprite;
    public var nightSprite: Sprite;
    var clock:Clock;
    public var hurryup: Bool;

    public function new() {
        super({name: "clock_ui"});

        var spriteTex = Luxe.resources.texture('assets/maps/sprites/clock.png');
        var hourTex = Luxe.resources.texture('assets/maps/sprites/clock_hour.png');
        var minTex = Luxe.resources.texture('assets/maps/sprites/clock_minutes.png');
        var nightTex = Luxe.resources.texture("assets/black_screen.png");

        clockSprite = new Sprite({
            name : "clock",
            pos : Luxe.screen.mid,
            texture : spriteTex
        });

        hourSprite = new Sprite({
            name : "hour",
            pos : Luxe.screen.mid,
            texture : hourTex
        });

        minSprite = new Sprite({
            name : "min",
            pos : Luxe.screen.mid,
            texture : minTex
        });


        nightSprite = new Sprite({
            name: "black",
            texture: nightTex,
            pos: Luxe.screen.mid,
            centered: true,
            color : new Color(1,1,1,0),
            depth:3
        });
    }

    public function check_night_rate() {
        var end = clock.endTime;
        var start = Clock.important_moments_time[2] + 2;
        var rate:Float = (clock.actualTime - start * 3600) / (end * 3600 - start * 3600);
        if (rate > 0) {
            nightSprite.color = new Color(1,1,1, rate);
        } else {
            if (rate < -1) {
                var newRate:Float = (Clock.important_moments_time[0] * 3600 - clock.actualTime) / (Clock.important_moments_time[0] * 3600 - clock.startTime * 3600);
                nightSprite.color = new Color(1,1,1, newRate);
            } else {
                nightSprite.color = new Color(1,1,1,0);
            }
        }
    }

    override public function init() {
        clock = cast entity;
    }

    override public function update(dt:Float) {
        hourSprite.rotation_z = clock.get_hour_float() * 30;
        minSprite.rotation_z = clock.get_minute_float() * 6;
        check_night_rate();

        if (clock.time_to_action && !hurryup) {
            hurryup = true;
            changeColor();
        } else if(!clock.time_to_action && hurryup){
            hurryup = false;
            changeColor();
        }
    }

    public function changeColor() {
        if (clock.time_to_action) {
            Actuate.tween (hourSprite.color,1, { r: 1, g:0, b:0, a:1});
            Actuate.tween (minSprite.color,1, { r: 1, g:0, b:0, a:1});
        } else {
            Actuate.tween (hourSprite.color,1, { r: 1, g:1, b:1, a:1});
            Actuate.tween (minSprite.color,1, { r: 1, g:1, b:1, a:1});
        }
    }


}
