import luxe.States;
import luxe.Parcel;
import luxe.Color;
import luxe.Input;

class Main extends luxe.Game {
    public static var fsm: luxe.States;

    override function config(config:luxe.AppConfig) {
        return config;
    } //config

    override function ready() {
        //Background Color
        Luxe.renderer.clear_color.rgb(0x495F69);
        //Loader de ressources
        Luxe.resources.load_json('assets/parcel.json').then(function(json) {
            var parcel = new Parcel();
            parcel.from_json(json.asset.json);
            new luxe.ParcelProgress({
                parcel      : parcel,
                background  : new Color(1,1,1,0.85),
                oncomplete  : assets_loaded
            });
            parcel.load();
        }, function(e) {
            trace(e);
        });
    } //ready

    function assets_loaded(_) {
        // diffentes scenes, comment les ajouters et les sets
        fsm = new States();
        fsm.add(new states.Play());
        fsm.add(new states.Splash());
        fsm.add(new states.Menu());
        fsm.set('Splash');
    }

    override function onkeyup( e:KeyEvent ) {
        //quitter l'appli
        if(e.keycode == Key.escape) {
            Luxe.shutdown();
        }
        if (e.keycode == Key.space) {
            Citizen.clock(MORNING);
        }

    } //onkeyup

    override function update(dt:Float) {

    } //update


} //Main
