package states;

import luxe.States;
import luxe.Scene;
import luxe.Color;
import luxe.importers.tiled.TiledMap;
import phoenix.Texture;
import phoenix.Vector;
import luxe.Entity;
import luxe.Sprite;
import luxe.tween.Actuate;

import map.MapLoader;
import Clock;

class Menu extends State {
    var menuScene:Scene;
    var menuSprite:Null<Sprite>;
    var geometry:Null<Sprite>;
    var text:Null<Sprite>;
    var radius:Float;

    public function new() {
        super({ name: 'Menu' });
        menuScene = new Scene('Menu');
        radius = 160;


    }

    override function onenter<T>(_:T) {
        var splash = Luxe.resources.texture("assets/splash_menu.png");
        menuSprite = new Sprite({
            name: "splashmenu",
            texture: splash,
            pos: Luxe.screen.mid,
            centered: true,
            scene : menuScene
        });

        var geom = Luxe.resources.texture("assets/play_button_background.png");
        //super(dt);
        geometry = new Sprite({
            name: "button",
            texture: geom,
            pos: Luxe.screen.mid,
            centered: true,
            scene : menuScene,
            depth:1
        });

        var geom2 = Luxe.resources.texture("assets/play_button_text.png");
        //super(dt);
        text = new Sprite({
            name: "buttontext",
            texture: geom2,
            pos: Luxe.screen.mid,
            centered: true,
            scene : menuScene,
            depth:2
        });
    }

    override function update(dt:Float) {
        Actuate.tween(geometry.size, 0.5, {x: radius, y: radius});
    }

    override function onmousemove(e) {
        var pos:Vector = e.pos;
        if (geometry.point_inside(pos)) {
            radius = 200;
        } else {
            radius = 150;
        }
    }

    override function onmouseup(e) {
        var pos:Vector = e.pos;
        if (geometry.point_inside(pos)) {
            Main.fsm.set("Play");
        }
    }
    override function onleave<T>(_:T) {
        text.destroy();
        geometry.destroy();
        menuSprite.destroy();
        menuScene.reset();
    }
}
